<?php
/**
 * K2 Xmap extension for Joomla!
 *
 * @copyright   2009 Denis Dulici
 * @license	    GNU General Public License
 * www.denisdulici.com
 * @package     Xmap
 */

defined( '_JEXEC' ) or die( 'Restricted access.' );

class xmap_com_k2 {

	function getTree( &$xmap, &$parent, &$params) {
		if (strpos($parent->link, 'view=item'))
			return $list;

		$link_query = parse_url( $parent->link );
        parse_str( html_entity_decode($link_query['query']), $link_vars );
        $ddCategoryid = JArrayHelper::getValue($link_vars,'category_id',0);

		$include_ddItems = JArrayHelper::getValue( $params, 'include_ddItems',1,'' );
		$include_ddItems = ( $include_ddItems == 1 || ( $include_ddItems == 2 && $xmap->view == 'xml') || ( $include_ddItems == 3 && $xmap->view == 'html'));
		$params['include_ddItems'] = $include_ddItems;

		$priority = JArrayHelper::getValue($params,'ddCats_priority',$parent->priority,'');
		$changefreq = JArrayHelper::getValue($params,'ddCats_changefreq',$parent->changefreq,'');
		if ($priority  == '-1')
			$priority = $parent->priority;
		if ($changefreq  == '-1')
			$changefreq = $parent->changefreq;

		$params['ddCats_priority'] = $priority;
		$params['ddCats_changefreq'] = $changefreq;

		$priority = JArrayHelper::getValue($params,'ddItems_priority',$parent->priority,'');
		$changefreq = JArrayHelper::getValue($params,'ddItems_changefreq',$parent->changefreq,'');
		if ($priority  == '-1')
			$priority = $parent->priority;

		if ($changefreq  == '-1')
			$changefreq = $parent->changefreq;

		$params['ddItems_priority'] = $priority;
		$params['ddItems_changefreq'] = $changefreq;

		if ( $include_ddItems ) {
			$params['limit'] = '';
			$params['days'] = '';
			$limit = JArrayHelper::getValue($params,'max_ddItems','','');

			if ( intval($limit) )
				$params['limit'] = ' LIMIT '.$limit;

			$days = JArrayHelper::getValue($params,'max_ddAge','','');
			if ( intval($days) )
				$params['days'] = ' AND created >= \''.date('Y-m-d H:m:s', ($xmap->now - ($days*86400)) ) ."' ";
		}

		xmap_com_k2::getDenisDuliciTree( $xmap, $parent, $params, $ddCategoryid );
	}

	function getDenisDuliciTree ( &$xmap, &$parent, &$params, &$ddCategoryid ) {
		$db = JFactory::getDBO();
		$db->setQuery("SELECT id, name, parent FROM #__jw_k2_categories WHERE parent = $ddCategoryid AND published = '1' ORDER BY name");
		$rows = $db->loadObjectList();
		$xmap->changeLevel(1);

		foreach($rows as $row) {
			$node = new stdclass;
			$node->id   = $parent->id;
			$node->uid  = $parent->uid.'c'.$row->id;   // Uniq ID for the cat
			$node->pid  = $row->parent;
			$node->name = $row->name? $row->name : $row->name;
			$node->priority   = $params['ddCats_priority'];
			$node->changefreq = $params['ddCats_changefreq'];
			$node->link = 'index.php?option=com_k2&amp;category='.$row->id.'&amp;view=itemlist';
			$node->tree = array();

			if ($xmap->printNode($node) !== FALSE ) {
				xmap_com_k2::getDenisDuliciTree($xmap, $parent, $params, $row->id);
			}
		}

		if ( $params['include_ddItems'] ) {
			$db->setQuery("SELECT id, title, catid, UNIX_TIMESTAMP(created) as created,  UNIX_TIMESTAMP(modified) as modified FROM #__jw_k2_items WHERE catid = $ddCategoryid AND published = '1' ORDER BY title");
			$rows = $db->loadObjectList();
			foreach($rows as $row) {
				$node = new stdclass;
				$node->id   = $parent->id;  // Itemid
				$node->uid  = $parent->uid .'i'.$row->id; // Uniq ID for the item
				$node->name = ($row->title ? $row->title : $row->title);
				$node->link = 'index.php?option=com_k2&amp;id='.$row->id.'&amp;view=item';
				$node->browserNav = $parent->browserNav;
				$node->modified = ($row->modified? $row->modified : $row->created);
				$node->priority   = $params['ddItems_priority'];
				$node->changefreq = $params['ddItems_changefreq'];
				$node->tree = array();
				$xmap->printNode($node);
			}
		}
		$xmap->changeLevel(-1);
	}

}
